using PkmnLib.Plugin.Gen7.Scripts.Pokemon;

namespace PkmnLib.Plugin.Gen7.Scripts.Moves;

[Script(ScriptCategory.Move, "skull_bash")]
public class SkullBash : Script, IScriptPreventMove, IScriptOnSecondaryEffect
{
    /// <inheritdoc />
    public void PreventMove(IExecutingMove move, ref bool prevent)
    {
        if (move.User.Volatile.Contains<SkullBashEffect>())
            return;
        move.User.ChangeStatBoost(Statistic.Defense, 1, true, false);
        move.User.Volatile.Add(new SkullBashEffect(move.User));
        prevent = true;
    }

    /// <inheritdoc />
    public void OnSecondaryEffect(IExecutingMove move, IPokemon target, byte hit)
    {
        move.User.Volatile.Remove<SkullBashEffect>();
    }
}